%define ALD_Ver		1.2.4
%define ICU_Ver		57.1
%define DATA_MIN	1

Name:         icu57

License:      ICU License
Summary:      International Components for Unicode
Group:        System Environment/Libraries
Version:      1
Release:      0

Source: icu-%{ICU_Ver}-svn.tar.xz
Source1: CROSS.sh
Source2: icu-%{ICU_Ver}-patches.tar.bz2

%define DestDir		/text

# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%define BUILD_LOCAL_CROSS 0
%else
# rpm --target=x86_64/armv6l/win32 -ba xxxxx.spec
%define _CROSS 1
%define BUILD_LOCAL_CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%if %{_CROSS}

%if %{_os} == "mingw"
%define target %{_arch}-%{_vendor}-%{_os}%{__isa_bits}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif
%define target_  %{target}-

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin

%define __os_install_post %{nil}

%define cross_bindir	%{csysdir}%{_bindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}
%define target_  %{nil}

%endif # !_CROSS

%define docdir %{_defaultdocdir}/%{name}

# ------------------- description ------------------------------------
%description
ICU is a set of C and C++ libraries that provides robust and full-featured
Unicode and locale support. The library provides calendar support, conversions
for many character sets, language sensitive collation, date
and time formatting, support for many locales, message catalogs
and resources, message formatting, normalization, number and currency
formatting, time zones support, transliteration, word, line and
sentence breaking, etc.
#-------------------------------
%package lib-data
Summary:      libicudata.so.57 
Group:        Documentation
%if %{_arch} == "x86_64"
Provides:     libicudata.so.57()(64bit)
%else
Provides:     libicudata.so.57
%endif
%description lib-data
libicudata.so.57
#-------------------------------
%package lib-data-min
Summary:      libicudata.so.57 
Group:        Documentation
%if %{_arch} == "x86_64"
Provides:     libicudata.so.57()(64bit)
%else
Provides:     libicudata.so.57
%endif
%description lib-data-min
libicudata.so.57
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
Group:        Development/Libraries
Requires:     %{name} = %{version}
%description devel
These libraries are needed to compile C code.
#-------------------------------
%package doc
Summary:      doc for %{name}
Group:        Documentation
%description doc
doc for %{name}
#-------------------------------
%package progs
Summary: Programs for manipulating GIF format image files.
Group: Applications/Multimedia
Requires: %{name} = %{version}
%description progs
This package contains various programs for manipulating gif image files.

#-------------------------------
%package %{TO_ARCH}
Summary:      %{name} Cross-%{TO_ARCH} Libraries
Group:        Development/Libraries
%description %{TO_ARCH}
%{name} Cross-%{TO_ARCH} Libraries

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n icu-%{ICU_Ver}-svn

tar -xaf %SOURCE2
patch -p1<patches/icudata-stdlibs.patch
patch -p1<patches/gennorm2-man.patch
patch -p1<patches/icuinfo-man.patch
patch -p1<patches/malayalam-rendering.patch
patch -p1<patches/indic-ccmp.patch
patch -p1<patches/CVE-2014-6585.patch
patch -p1<patches/CVE-2015-4760.patch
patch -p1<patches/CVE-2016-0494.patch
patch -p1<patches/CVE-2016-6293.patch
patch -p1<patches/CVE-2016-7415.patch

%if %{DATA_MIN}
cp -ar patches/mk-min/* source/data/
%endif

sed -i s:" \$(ICUPKGDATA_DIR)":" \$(DESTDIR)\$(ICUPKGDATA_DIR)": source/data/Makefile.in
sed -i s:"(INSTALL) ":"(INSTALL) -m 644 ": source/data/pkgdataMakefile.in


# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

GCC_VER_STR=`%{target_}gcc -dumpversion`

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-asynchronous-unwind-tables -fno-dwarf2-cfi-asm" ;; esac`
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-asynchronous-unwind-tables -fno-dwarf2-cfi-asm" ;; esac`
%endif
%if %{_arch} == "arm"
OPTFLAGS="-Os -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
OPT47=
%endif

CFLAGS="-pipe $OPTFLAGS $OPT47 -ffunction-sections -fdata-sections -D_GNU_SOURCE -std=gnu99"
CXXFLAGS="-pipe $OPTFLAGS $OPT47 -ffunction-sections -fdata-sections -fno-exceptions -D_GNU_SOURCE"
LDFLAGS="-Wl,--gc-sections"

cd source

%configure \
	--build=%{_build} \
%if %{_CROSS}
	--host=%{target} \
%endif
%if %{_os} == "mingw"
	--disable-shared \
	--enable-static \
%else
	--enable-shared \
	--disable-static \
%endif
	--disable-rpath \
	--with-data-packaging=library \
	--disable-samples \
	--disable-tests \
%if %{DATA_MIN}
	--disable-extras \
	--disable-icuio \
	--disable-layout \
	--disable-layoutex \
%endif
	&>FConfigure_log.txt

#	--with-data-packaging=files 


#echo 'CPPFLAGS += -DICU_DATA_DIR=\"/usr/share/icu/%{ICU_Ver}\"' >> icudefs.mk

make &>FMake_log.txt

cd ..

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}/html

cd source
make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
cd ..

%if %{DATA_MIN}
rm -r $RPM_BUILD_ROOT%{_bindir}
rm -r $RPM_BUILD_ROOT%{_includedir}
rm -r $RPM_BUILD_ROOT%{_libdir}/icu
rm -r $RPM_BUILD_ROOT%{_libdir}/pkgconfig
rm -r $RPM_BUILD_ROOT%{_libdir}/libicudata.so
rm -r $RPM_BUILD_ROOT%{_libdir}/libicui18n.*
rm -r $RPM_BUILD_ROOT%{_libdir}/libicutest.*
rm -r $RPM_BUILD_ROOT%{_libdir}/libicutu.*
rm -r $RPM_BUILD_ROOT%{_libdir}/libicuuc.*
rm -r $RPM_BUILD_ROOT%{_sbindir}
rm -r $RPM_BUILD_ROOT%{_datadir}
%else
cp LICENSE $RPM_BUILD_ROOT%{docdir}/
rm $RPM_BUILD_ROOT%{_datadir}/icu/%{ICU_Ver}/LICENSE
%endif

%if %{_CROSS}
TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=%{BUILD_LOCAL_CROSS}
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR
%SOURCE1
%if %{BUILD_LOCAL_CROSS}
rm -r $RPM_BUILD_ROOT%{cross_bindir}
%endif #BUILD_LOCAL_CROSS
%endif #_CROSS

%if !%{DATA_MIN}
%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif
%endif


# ------------------- Clean ------------------------------------------
%Clean 
DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
DEC=%{version}-%{release}.%{_build_cpu}.rpm
DDC=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
%if %{DATA_MIN}
  mkdir -p $DD
  mv %{name}-lib-data-min-$SE $DD/%{name}-lib-data-min-$DE
%else
%if (%{_os} == "mingw")
  rm %{name}-$SE
%if %{BUILD_LOCAL_CROSS}
  mkdir -p $DDC
  mv %{name}-%{TO_ARCH}-$SE $DDC/%{name}-%{TO_ARCH}-$DEC
%endif #BUILD_LOCAL_CROSS
%else  #mingw
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-lib-data-$SE $DD/%{name}-lib-data-$DE
  mv %{name}-devel-$SE $DD/%{name}-devel-$DE
  mv %{name}-doc-$SE $DD/%{name}-doc-$DE
  mv %{name}-progs-$SE $DD/%{name}-progs-$DE
%if %{BUILD_LOCAL_CROSS}
  mkdir -p $DDC
  mv %{name}-%{TO_ARCH}-$SE $DDC/%{name}-%{TO_ARCH}-$DEC
%endif #BUILD_LOCAL_CROSS
%endif #!mingw
%endif #!DATA_MIN
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
%if (%{_os} == "mingw")
  TMP_TO=$DD
%else
  TMP_TO=$DD/tar
%endif
  mkdir -p $TMP_TO
%if %{DATA_MIN}
  tmp=%{name}-lib-data-min-%{version}-%{release}.%{TO_ARCH}
%else
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
%endif
  mkdir -p $tmp
  cp -r usr $tmp/
%if (%{_os} == "mingw")
  zip -9 -r $tmp.zip $tmp >/dev/null
  mv $tmp.zip $TMP_TO
%else
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
%endif
  rm -r $tmp
%if %{BUILD_LOCAL_CROSS}
  TMP_TO=$DDC/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{TO_ARCH}-%{version}-%{release}.%{_build_cpu}
  mkdir -p $tmp
  cp -r cross $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%endif
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------
%if %{DATA_MIN}
%files lib-data-min
%{_libdir}/libicudata.so.*
%else  # DATA_MIN

%if %{_os} == "mingw"
%files
%{_prefix}

%if %{BUILD_LOCAL_CROSS}
%files %{TO_ARCH}
%{csysdir}
%endif #!BUILD_LOCAL_CROSS
%else  #mingw

%files
%{_libdir}/libicui18n.so.*
%{_libdir}/libicuio.so.*
%{_libdir}/libicule.so.*
%{_libdir}/libiculx.so.*
%{_libdir}/libicutest.so.*
%{_libdir}/libicutu.so.*
%{_libdir}/libicuuc.so.*
%{docdir}/LICENSE
#{_datadir}/icu/%{ICU_Ver}

%files lib-data
%{_libdir}/libicudata.so.*

%files devel
%{_bindir}/icu-config
%{_includedir}
%{_libdir}/*.so
%{_libdir}/icu
%{_libdir}/pkgconfig
%{_datadir}/icu/%{ICU_Ver}/config
%{_datadir}/icu/%{ICU_Ver}/install-sh
%{_datadir}/icu/%{ICU_Ver}/mkinstalldirs

%files doc
%{docdir}/html

%files progs
%exclude %{_bindir}/icu-config
%{_bindir}
%{_sbindir}
%{_mandir}

%if %{BUILD_LOCAL_CROSS}

%files %{TO_ARCH}
%{cross_libdir}/*.so.*
%{cross_libdir}/*.so
%{cross_includedir}
%{cross_docdir}

%endif #!BUILD_LOCAL_CROSS
%endif #!mingw
%endif # DATA_MIN
